import copy

def calcAvDmg(beforeD,afterD,flatBonus=0):
	sum = 0
	divisionValue = afterD**beforeD
	
	def recursionCAD(range,stop,sum=0,vList=[]):	
		sum = 0
		x = 0
		if stop > 0:
			for x in range:
				newList = copy.copy(vList)
				newList.append(x)
				sum+=recursionCAD(range,stop-1,sum,newList)
			return sum
		else:
			for v in vList:
				sum+=v
			return sum
	result = recursionCAD(range(1,afterD+1),beforeD)
	result = result/divisionValue
	result += flatBonus
	return result
	
def noAdvantageThor(enemyAC,playerLevel=3,silent=False):
	critFails = 0
	misses = 0
	hits = 0
	critSuccess = 0
	for x in range(1,21):
		if x==1:
			critFails+=1
		elif x==20:
			critSuccess+=1
		elif x+8<=enemyAC:
			misses+=1
		elif x+8>enemyAC:
			hits+=1
	
	avDmg = calcAvDmg(1,6,1+playerLevel)	
	critDmg = avDmg+calcAvDmg(1,6)	
	
	newAvDmg = (critSuccess*critDmg+hits*avDmg)/20
	selfDmg = (critFails*calcAvDmg(1,4)+critSuccess*(playerLevel//2)+hits*(playerLevel//2))/20
	toSay = ""
	toSay = "Thor stats for AC("+str(enemyAC)+")\n\taverage Dmg:"+str(newAvDmg)+" average self damage:"+str(selfDmg) + '\n'
	toSay += "\tcrit fails:"+str(100*critFails/20)+" crit successes:"+ str(100*critSuccess/20) + '\n'
	if not silent:
		print(toSay)
	return (newAvDmg,selfDmg,100*(hits+critSuccess)/20,100*(misses+critFails)/20,100*critFails/20,100*critSuccess/20)

def versatlieThor(enemyAC,HitD,DHit,dmgD,Ddmg,STR,playerLevel,silent=True):	
	def recursion(r,stop,flatBonus,enemyAC,vList=[],silent=True):
		sum = [0,0,0,0]
		if stop>0:
			for x in r:
				newList = copy.copy(vList)
				newList.append(x)
				rec=recursion(r,stop-1,flatBonus,enemyAC,newList,silent)
				if not silent:
					print(rec)
				for i in range(len(sum)):
					sum[i]+=rec[i]
			return sum
		else:
			value = 0
			vNotMin = False
			vNotMax = False
			for v in vList:
				value+=v
				if v!=r.start:
					vNotMin = True
				if (v+1)!=r.stop:
					vNotMax = True
			if not silent:
				toSay = ""
				#toSay += 'v:'+str(v)+" rolls:"+vList.__str__()
				print(toSay)
			if not vNotMin:
				sum[0]=1	#crit fail
			elif not vNotMax:
				sum[3]=1	#crit success
			elif value+flatBonus<=enemyAC:
				sum[1]=1	#miss
			elif value+flatBonus>enemyAC:
				sum[2]=1	#hit
			return sum
	result = recursion(range(1,DHit+1),HitD,2+STR,enemyAC,[],silent)
	if not silent:
		print(result)
	
	critFails = result[0]
	misses = result[1]
	hits = result[2]
	critSuccess = result[3]
	all = critFails+misses+hits+critSuccess
	avDmg = calcAvDmg(dmgD,Ddmg,1+playerLevel)	
	critDmg = avDmg+calcAvDmg(dmgD,Ddmg)	
	
	newAvDmg = (critSuccess*critDmg+hits*avDmg)/all
	selfDmg = (critFails*calcAvDmg(1,4)+critSuccess*(playerLevel//2)+hits*(playerLevel//2))/all
	toSay = 'nothing'
	toSay = "Thor stats for AC("+str(enemyAC)+") for hit roll of "+str(HitD)+'d'+str(DHit)+"+"+str(2+STR)+" with weapon "+str(dmgD)+'d'+str(Ddmg)+"+"+str(1+playerLevel)+'\n'
	toSay +="\taverage Dmg:"+str(newAvDmg)+" average self damage:"+str(selfDmg) +'\n'
	toSay += "\tcrit fails:"+str(100*critFails/all)+"% crit successes:"+ str(100*critSuccess/all)+"% hit chance:"+str(100*(critSuccess+hits)/all)+'%\n'
	if not silent:
		print(toSay)
	return (newAvDmg,selfDmg,100*(hits+critSuccess)/all,100*(misses+critFails)/all,100*critFails/all,100*critSuccess/all)

	
def advantegeHandAxe(enemyAC,beforeD,afterD,silent=False):
	critFails = 0
	misses = 0
	hits = 0
	critSuccess = 0
	divisionValue = 20*20
	for x in range(1,21):
		for y in range(1,21):
			value = max(x,y)
			if value==1:
				critFails+=1
			elif value==20:
				critSuccess+=1
			elif value+6<=enemyAC:
				misses+=1
			elif value+6>enemyAC:
				hits+=1
	
	avDmg = calcAvDmg(beforeD,afterD)	
	critDmg = avDmg+calcAvDmg(beforeD,afterD)	
	
	newAvDmg = (critSuccess*critDmg+hits*avDmg)/divisionValue
	selfDmg = (critFails*calcAvDmg(1,4))/divisionValue
	toSay = ""
	toSay += "Handaxe stats for AC("+str(enemyAC)+")\n\taverage Dmg:"+str(newAvDmg)+" average self damage:"+str(selfDmg)+'\n'
	toSay += "\tcrit fails:"+str(100*critFails/divisionValue)+" crit successes:"+ str(100*critSuccess/divisionValue)
	if not silent:
		print(toSay)
	return (newAvDmg,selfDmg,100*(hits+critSuccess)/20,100*(misses+critFails)/20,100*critFails/divisionValue,100*critSuccess/divisionValue)

def compareAdvantageAndThor():	
	print("data legend:( average dmg, average self dmg, hits %, misses %,crit fails %, crit successes %)")
	for x in range(1,31):
		ThorData = noAdvantageThor(x,3,True)
		axeData = advantegeHandAxe(x,1,6,True)
		print("For AC("+str(x)+") \tThor data:"+ThorData.__str__()+" \taxe data:"+axeData.__str__())
	#How could Frogs strong defences failed?
def start():
	print("data legend:( average dmg, average self dmg, hits %, misses %, crit fails %, crit successes %)")
	for x in range(1,31):
		ThorData1 = versatlieThor(x,10,2,1,6,4,3,True)
		ThorData2 = versatlieThor(x,1,20,1,6,6,3,True)
		print("For AC("+str(x)+") \tThor1 data:"+ThorData1.__str__()+"\tThor2 data:"+ThorData2.__str__())
	
#https://rpg.stackexchange.com/questions/83380/does-damage-from-an0enchanted-weapon-automatically-count-as-magical-damage

#éččéęëěííîŢčÝŢßçćčéęëěí